/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstylehintreturnmask_wrapper.h"

// Extra includes



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleHintReturnMask_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QStyleHintReturnMask >()))
        return -1;

    QStyleHintReturnMask* cptr = 0;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);

    // Call function/method
    {
        {

            if(!PyErr_Occurred()) {
                // QStyleHintReturnMask()
                PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                cptr = new QStyleHintReturnMask();
                PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QStyleHintReturnMask >(), cptr)) {
        delete cptr;
        return -1;
    }
    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyMethodDef Sbk_QStyleHintReturnMask_methods[] = {

    {0} // Sentinel
};

static PyObject* Sbk_QStyleHintReturnMask_get_region(PyObject* self, void*)
{
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleHintReturnMask* >::toCpp(self)->region);
    Shiboken::Object::releaseOwnership(val);
    return val;
}

static int Sbk_QStyleHintReturnMask_set_region(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'region' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QRegion >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'region', 'QRegion' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleHintReturnMask* >::toCpp(self)->region = Shiboken::Converter< ::QRegion >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleHintReturnMask
static PyGetSetDef Sbk_QStyleHintReturnMask_getsetlist[] = {
    {const_cast<char*>("region"), Sbk_QStyleHintReturnMask_get_region, Sbk_QStyleHintReturnMask_set_region},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleHintReturnMask_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QStyleHintReturnMask",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleHintReturnMask_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleHintReturnMask_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleHintReturnMask_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QStyleHintReturnMask(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNMASK_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleHintReturnMask_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QStyleHintReturnMask_Type);
    Sbk_QStyleHintReturnMask_Type.super.ht_type.tp_base = SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURN_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QStyleHintReturnMask_Type, &Shiboken::callCppDestructor<QStyleHintReturnMask >);
    if (PyType_Ready((PyTypeObject*)&Sbk_QStyleHintReturnMask_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QStyleHintReturnMask_Type, "QStyleHintReturnMask*");
    PyModule_AddObject(module, "QStyleHintReturnMask",
        ((PyObject*)&Sbk_QStyleHintReturnMask_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: StyleOptionVersion
    PyTypeObject* SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionVersion = Shiboken::Enum::newType("PySide.QtGui.QStyleHintReturnMask.StyleOptionVersion");
    SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNMASK_STYLEOPTIONVERSION_IDX] = SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionVersion;
    if (PyType_Ready(SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionVersion) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleHintReturnMask_Type.super.ht_type.tp_dict,
            "StyleOptionVersion",((PyObject*)SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionVersion));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionVersion,(long) QStyleHintReturnMask::Version, "Version");
    PyDict_SetItemString(Sbk_QStyleHintReturnMask_Type.super.ht_type.tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionVersion->tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleHintReturnMask::StyleOptionVersion");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionVersion");
    // end of enum StyleOptionVersion

    // init enum: StyleOptionType
    PyTypeObject* SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionType = Shiboken::Enum::newType("PySide.QtGui.QStyleHintReturnMask.StyleOptionType");
    SbkPySide_QtGuiTypes[SBK_QSTYLEHINTRETURNMASK_STYLEOPTIONTYPE_IDX] = SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionType;
    if (PyType_Ready(SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionType) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleHintReturnMask_Type.super.ht_type.tp_dict,
            "StyleOptionType",((PyObject*)SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionType,(long) QStyleHintReturnMask::Type, "Type");
    PyDict_SetItemString(Sbk_QStyleHintReturnMask_Type.super.ht_type.tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleHintReturnMask_StyleOptionType->tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleHintReturnMask::StyleOptionType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionType");
    // end of enum StyleOptionType


    Shiboken::TypeResolver::createObjectTypeResolver<QStyleHintReturnMask >("QStyleHintReturnMask*");
    Shiboken::TypeResolver::createObjectTypeResolver<QStyleHintReturnMask >(typeid(QStyleHintReturnMask).name());
    PySide::initQtMetaType< ::QStyleHintReturnMask* >();
    qRegisterMetaType< ::QStyleHintReturnMask::StyleOptionVersion >("QStyleHintReturnMask::StyleOptionVersion");
    qRegisterMetaType< ::QStyleHintReturnMask::StyleOptionType >("QStyleHintReturnMask::StyleOptionType");
}

