/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptionfocusrect_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionFocusRect_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QStyleOptionFocusRect >()))
        return -1;

    QStyleOptionFocusRect* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionFocusRect", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: QStyleOptionFocusRect()
    // 1: QStyleOptionFocusRect(QStyleOptionFocusRect)
    // 2: QStyleOptionFocusRect(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionFocusRect()
    } else if (numArgs == 1 && SbkNumber_Check(pyargs[0])) {
        overloadId = 2; // QStyleOptionFocusRect(int)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionFocusRect >::isConvertible(pyargs[0])) {
        overloadId = 1; // QStyleOptionFocusRect(QStyleOptionFocusRect)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionFocusRect_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QStyleOptionFocusRect()
            {

                if(!PyErr_Occurred()) {
                    // QStyleOptionFocusRect()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionFocusRect();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // QStyleOptionFocusRect(QStyleOptionFocusRect)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionFocusRect cppArg0 = Shiboken::Converter<QStyleOptionFocusRect >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionFocusRect(QStyleOptionFocusRect)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionFocusRect(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 2: // QStyleOptionFocusRect(int)
            {
                int cppArg0 = Shiboken::Converter<int >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionFocusRect(int)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionFocusRect(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QStyleOptionFocusRect >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionFocusRect_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionFocusRect_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionFocusRect", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionFocusRect", overloads);
        return -1;
}

static PyObject *Sbk_QStyleOptionFocusRect___copy__(PyObject *self)
{
        QStyleOptionFocusRect* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QStyleOptionFocusRect*>::toCpp(self);
        PyObject* pyResult = 0;
        QStyleOptionFocusRect* copy = new QStyleOptionFocusRect(*cppSelf);
        pyResult = Shiboken::Converter<QStyleOptionFocusRect*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QStyleOptionFocusRect_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QStyleOptionFocusRect___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionFocusRect_get_backgroundColor(PyObject* self, void*)
{
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionFocusRect* >::toCpp(self)->backgroundColor);
    Shiboken::Object::releaseOwnership(val);
    return val;
}

static int Sbk_QStyleOptionFocusRect_set_backgroundColor(PyObject* self, PyObject* value, void*)
{
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'backgroundColor' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QColor >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'backgroundColor', 'QColor' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionFocusRect* >::toCpp(self)->backgroundColor = Shiboken::Converter< ::QColor >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleOptionFocusRect
static PyGetSetDef Sbk_QStyleOptionFocusRect_getsetlist[] = {
    {const_cast<char*>("backgroundColor"), Sbk_QStyleOptionFocusRect_get_backgroundColor, Sbk_QStyleOptionFocusRect_set_backgroundColor},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionFocusRect_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QStyleOptionFocusRect",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionFocusRect_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionFocusRect_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionFocusRect_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern


void init_QStyleOptionFocusRect(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionFocusRect_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QStyleOptionFocusRect_Type);
    Sbk_QStyleOptionFocusRect_Type.super.ht_type.tp_base = SbkPySide_QtGuiTypes[SBK_QSTYLEOPTION_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QStyleOptionFocusRect_Type, &Shiboken::callCppDestructor<QStyleOptionFocusRect >);
    if (PyType_Ready((PyTypeObject*)&Sbk_QStyleOptionFocusRect_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QStyleOptionFocusRect_Type, "QStyleOptionFocusRect");
    PyModule_AddObject(module, "QStyleOptionFocusRect",
        ((PyObject*)&Sbk_QStyleOptionFocusRect_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: StyleOptionVersion
    PyTypeObject* SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionVersion = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionFocusRect.StyleOptionVersion");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONVERSION_IDX] = SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionVersion;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionVersion) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionFocusRect_Type.super.ht_type.tp_dict,
            "StyleOptionVersion",((PyObject*)SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionVersion));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionVersion,(long) QStyleOptionFocusRect::Version, "Version");
    PyDict_SetItemString(Sbk_QStyleOptionFocusRect_Type.super.ht_type.tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionVersion->tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionFocusRect::StyleOptionVersion");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionVersion");
    // end of enum StyleOptionVersion

    // init enum: StyleOptionType
    PyTypeObject* SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionType = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionFocusRect.StyleOptionType");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONFOCUSRECT_STYLEOPTIONTYPE_IDX] = SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionType;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionType) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionFocusRect_Type.super.ht_type.tp_dict,
            "StyleOptionType",((PyObject*)SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionType,(long) QStyleOptionFocusRect::Type, "Type");
    PyDict_SetItemString(Sbk_QStyleOptionFocusRect_Type.super.ht_type.tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionFocusRect_StyleOptionType->tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionFocusRect::StyleOptionType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionType");
    // end of enum StyleOptionType


    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionFocusRect >("QStyleOptionFocusRect");
    Shiboken::TypeResolver::createObjectTypeResolver<QStyleOptionFocusRect >("QStyleOptionFocusRect*");
    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionFocusRect >(typeid(QStyleOptionFocusRect).name());
    PySide::initQtMetaType< ::QStyleOptionFocusRect >();
    qRegisterMetaType< ::QStyleOptionFocusRect::StyleOptionVersion >("QStyleOptionFocusRect::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionFocusRect::StyleOptionType >("QStyleOptionFocusRect::StyleOptionType");
}

